#include "U8glib.h"
U8GLIB_64128N u8g(4,5, 1, 3, 2);

void draw(void) {
 int cols = u8g.getHeight();
 int rows = u8g.getWidth();
 u8g.setFont(u8g_font_unifont);
 int hs = u8g.getFontAscent()-u8g.getFontDescent();
 int ws = u8g.getStrWidth("NOKIA 3410");
 u8g.drawStr( 8, 14, "NOKIA 3410");
 u8g.drawFrame(8-2, 1, ws+4, hs+3) ;
 u8g.setPrintPos( 0, 34 );
 u8g.print(cols);
 u8g.print("=> Px on Y");
 u8g.setPrintPos( 0, 46 );
 u8g.print(rows);
 u8g.print("=> Px on X");
 u8g.drawLine(5,50,90,50);
 u8g.setPrintPos( 5, 62 );
 u8g.setFont(u8g_font_tpss);
 u8g.print("12 Cols / 8 Rows");
}

void setup(void) {

  if ( u8g.getMode() == U8G_MODE_R3G3B2 ) {
    u8g.setColorIndex(255);     // white
  }
  else if ( u8g.getMode() == U8G_MODE_GRAY2BIT ) {
    u8g.setColorIndex(3);         // max intensity
  }
  else if ( u8g.getMode() == U8G_MODE_BW ) {
    u8g.setColorIndex(1);         // pixel on
  }
  else if ( u8g.getMode() == U8G_MODE_HICOLOR ) {
    u8g.setHiColorByRGB(255,255,255);
  }
}

void loop(void) {
  // picture loop
  u8g.firstPage();  
  do {
    draw();
  } while( u8g.nextPage() );
  
  // rebuild the picture after some delay
  delay(50);
}

