#include "U8glib.h"
#include "utility/u8g.h"
const u8g_fntpgm_uint8_t chinese_test[55] U8G_SECTION(".progmem.chinese_test") = {
  0,16,16,0,254,0,0,0,0,0,27,27,0,14,254,0,
  0,14,16,32,16,0,254,8,4,8,4,20,4,18,36,33,
  36,64,164,190,36,34,36,34,36,34,36,42,36,36,36,32,
  132,32,132,31,148,0,8};

U8GLIB_64128N u8g(4,5, 1, 3, 2); 

void draw(void) {
  // graphic commands to redraw the complete screen should be placed here  
  u8g.setFont(chinese_test);
  //u8g.setFont(u8g_font_osb21);
  u8g.drawStr( 0, 22, "\x1b");
}

void setup(void) {

  // flip screen, if required
  // u8g.setRot180();

  // set SPI backup if required
  //u8g.setHardwareBackup(u8g_backup_avr_spi);

  // assign default color value
  if ( u8g.getMode() == U8G_MODE_R3G3B2 ) 
    u8g.setColorIndex(255);     // white
  else if ( u8g.getMode() == U8G_MODE_GRAY2BIT )
    u8g.setColorIndex(3);         // max intensity
  else if ( u8g.getMode() == U8G_MODE_BW )
    u8g.setColorIndex(1);         // pixel on
}

void loop(void) {
  // picture loop
  u8g.firstPage();  
  do {
    draw();
  } while( u8g.nextPage() );

  // rebuild the picture after some delay
  delay(500);
}
