#include "U8glib.h"
#include <math.h>

U8GLIB_64128N u8g(4,5, 1, 3, 2); 


void u8g_prepare(void) {
  u8g.setFont(u8g_font_6x10);
  u8g.setFontRefHeightExtendedText();
  u8g.setDefaultForegroundColor();
  u8g.setFontPosTop();
}


void setup(void) {
  // flip screen, if required
  //u8g.setRot180();
  // assign default color value
  if ( u8g.getMode() == U8G_MODE_R3G3B2 )
    u8g.setColorIndex(255);     // white
  else if ( u8g.getMode() == U8G_MODE_GRAY2BIT )
    u8g.setColorIndex(3);         // max intensity
  else if ( u8g.getMode() == U8G_MODE_BW )
    u8g.setColorIndex(1);         // pixel on 
  //u8g.setContrast(0x30); 
  pinMode(13, OUTPUT);          
  digitalWrite(13, HIGH);  
  u8g_prepare();  
}

void draw(void) { 
  float supply = 4.91; // Here must be entered the measured supply voltage of the arduino board
//read the sensor output voltage
int reading = analogRead(0);
float v_out = (reading * supply)/1.024;
// show on the LCD the temperature
float temperature = (v_out - 509)/6.45 ;
char temp[5];
dtostrf(temperature,5,1,temp);
u8g.drawStr(4,24,"Temperature:");
u8g.drawStr(76,24,temp);
u8g.drawStr(108,24,"\260C");
}

void loop(void) {
 
  // picture loop 
  u8g.firstPage(); 
  do {
    draw();
  } while( u8g.nextPage() );
   
  // rebuild the picture after some delay
  delay(1000);
}
